#include <nds.h>
#include <fat.h>
#include <stdio.h>
#include <sys/stat.h>

#include "minIni.h"

char* myfgets(char *buf,int n,FILE *fp){
	char *ret=fgets(buf,n,fp);
	if(!ret)return NULL;
	if(strlen(buf)&&buf[strlen(buf)-1]=='\n')buf[strlen(buf)-1]=0;
	if(strlen(buf)&&buf[strlen(buf)-1]=='\r')buf[strlen(buf)-1]=0;
	return ret;
}

u32 crc32(u32 crc, const u8 *p, u32 size){
	int n,f;
	for(;size;size--){
		crc^=*p++;
		for(n=0;n<8;n++){
			f = crc & 1;
			crc >>= 1 ;
			if(f)crc^=0xedb88320;
		}
	}
	return crc;
}

unsigned int read32(const void *p){
	const unsigned char *x=(const unsigned char*)p;
	return x[0]|(x[1]<<8)|(x[2]<<16)|(x[3]<<24);
}

unsigned short read16(const void *p){
	const unsigned char *x=(const unsigned char*)p;
	return x[0]|(x[1]<<8);
}

#define SAVE_INFO_EX_DOWNLOAD_PLAY 0x04
#define SAVE_INFO_EX_SOFT_RESET 0x08
#define SAVE_INFO_EX_CHEAT 0x10
//#define SAVE_INFO_EX_SLOT_MASK 0x60
//#define SAVE_INFO_EX_SLOT_SHIFT 5
#define SAVE_INFO_EX_DMA 0x80

#define SAVE_INFO_EX_GLOBAL_DOWNLOAD_PLAY 0x00000001
#define SAVE_INFO_EX_GLOBAL_SOFT_RESET 0x00000002
#define SAVE_INFO_EX_GLOBAL_CHEAT 0x00000004
#define SAVE_INFO_EX_GLOBAL_DMA 0x00000008

extern u8* io_dldi_data;
int g_cheats,g_softreset,g_dma,g_downloadplay=0;

typedef struct{
	u32 gamecode;
	u32 crc32;
	u64 offset;
}cheatindex;

void run(){
	char _filename[768],*filename=_filename;
	FILE *f;

	consoleDemoInit();

	iprintf("menudowood\n\n");
 
	iprintf("Initializing libfat... ");
	if(!fatInitDefault()){iprintf("Failed.\n");return;}
	iprintf("Done.\n");

	iprintf("Reading /loadfile.dat... ");
	f=fopen("/loadfile.dat","rb");
	if(!f){iprintf("Failed.\n");return;}
	myfgets(_filename,768,f);
	fclose(f);
	remove("/loadfile.dat");
	if(!memcmp(_filename,"//",2))filename+=1;
	if(!memcmp(_filename,"/./",3))filename+=2;
	iprintf("Done.\n");

	strcpy((char*)0x023fda00,"fat0:");
	strcpy((char*)0x023fda05,filename);
	strcpy((char*)0x023fdd00,"fat0:");
	strcpy((char*)0x023fdd05,filename);

	//read globalsettings.ini
	iprintf("Reading globalsettings.ini...\n");
	g_cheats=ini_getl("system","cheats",0,"/__rpg/globalsettings.ini");
	g_softreset=ini_getl("system","softreset",0,"/__rpg/globalsettings.ini");
	g_dma=ini_getl("system","dma",0,"/__rpg/globalsettings.ini");
	char *saveext=(char*)0x023fdd05;
	saveext=saveext+strlen(saveext)-4;
	ini_gets("system","saveext",".sav",saveext,9,"/__rpg/globalsettings.ini");

	//read gamedata.bin
	iprintf("Reading gamedata.bin... ");
	u32 gamecode;
	u32 CRC32;
	u8 head[512];
	{
		u16 CRC16;
		if(!(f=fopen(filename,"rb"))){iprintf("Cannot open ROM.\n");return;}
		fread(head,1,512,f);
		fclose(f);
		gamecode=read32(head+12);
		CRC16=read16(head+0x15e);
		CRC32=crc32(0xffffffff,head,512);

		u8 buf[32];
		if(!(f=fopen("/__rpg/gamedata.bin","rb")))goto notparse;
		fread(buf,1,16,f);
		u32 count=read32(buf+8);
		if(memcmp(buf,"AKGB",4)||read32(buf+4)!=0x20){fclose(f);goto notparse;}
		u32 i=0;
		for(;i<count;i++){
			fread(buf,1,32,f);
			if(!memcmp(buf,head,12)&&gamecode==read32(buf+12)&&CRC16==read16(buf+16)){
				if(!(read32(buf+20)&SAVE_INFO_EX_GLOBAL_DOWNLOAD_PLAY))g_downloadplay=buf[19]&SAVE_INFO_EX_DOWNLOAD_PLAY;
				if(!(read32(buf+20)&SAVE_INFO_EX_GLOBAL_SOFT_RESET))g_softreset=buf[19]&SAVE_INFO_EX_SOFT_RESET;
				if(!(read32(buf+20)&SAVE_INFO_EX_GLOBAL_CHEAT))g_cheats=buf[19]&SAVE_INFO_EX_CHEAT;
				if(!(read32(buf+20)&SAVE_INFO_EX_GLOBAL_DMA))g_dma=buf[19]&SAVE_INFO_EX_DMA;
				break;
			}
		}
		fclose(f);
	}
notparse:
	iprintf("Done.\n");

	*(vu32*)0x023fd900=0x10|(14<<8);
	if(g_downloadplay)*(vu32*)0x023fd900|=1;
	if(g_softreset)*(vu32*)0x023fd900|=4;
	if(g_dma)*(vu32*)0x023fd900|=8;
	if(g_cheats){
		iprintf("Reading usrcheat.dat... ");
		if(f=fopen("/__rpg/cheats/usrcheat.dat","rb")){
			fread(head,1,12,f);
			if(!memcmp(head,"R4 CheatCode",12)){
				struct stat st;fstat(fileno(f),&st);
				u32 fsize=st.st_size;
				fseek(f,0x100,SEEK_SET);
				cheatindex cur,next;
				fread(&next,1,sizeof(next),f);
				for(;;){
					memcpy(&cur,&next,sizeof(cur));
					fread(&next,1,sizeof(next),f);
					if(gamecode==cur.gamecode&&CRC32==cur.crc32){
						*(vu32*)0x023fd904=cur.offset; //offset
						*(vu32*)0x023fd908=(next.offset?next.offset:fsize)-cur.offset; //size
						//u8 *p=(u8*)malloc(*(vu32*)0x023fd908);
						//if(p){
						//	fseek(f,*(vu32*)0x023fd904,SEEK_SET);
						//	fread(p,1,*(vu32*)0x023fd908,f);
						//	u32 count=*(u32*)( p+align4(strlen((char*)p)+1) );
						//	if(count&0xf0000000){ //enable it
								*(vu32*)0x023fd900|=2; //enable cheating.
						//	}
						//	free(p);
						//}
						iprintf("Done.\n");
						break;
					}
					if(!next.offset){
						iprintf("Not found.\n");
						break;
					}
				}
			}
			fclose(f);
		}
	}

	char dldiid[5];dldiid[4]=0;
	memcpy(dldiid,io_dldi_data+0x60,4);
	ini_gets("WoodMod",dldiid,"/__rpg/r4loader.nds",filename,768,"/__rpg/woodload.ini");
	iprintf("Rebooting...\n");
	_runNds(filename);
}

int main(){
	run();
	iprintf("Press A to shutdown.\n");
	while(1){
		swiWaitForVBlank();
		scanKeys();
		if(keysHeld()&KEY_A)return 0;
	}

	return 0;
}
